"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.upsertRoleAssignment = exports.listOf = void 0;
const authArm = __importStar(require("@azure/arm-authorization"));
const t = __importStar(require("io-ts"));
const validation = __importStar(require("@data-heaving/common-validation"));
const uuid = __importStar(require("uuid"));
const listOf = (item) => t.array(item, `${item.name}List`);
exports.listOf = listOf;
const upsertRoleAssignment = async (clientOrArgs, scope, roleDefinitionUuId, principalId) => {
    const client = Array.isArray(clientOrArgs)
        ? new authArm.AuthorizationManagementClient(...clientOrArgs)
        : clientOrArgs;
    const roleDefinitionId = `/subscriptions/${client.subscriptionId}/providers/Microsoft.Authorization/roleDefinitions/${roleDefinitionUuId}`;
    const { roleAssignments } = client;
    return (validation
        .decodeOrThrow((0, exports.listOf)(roleAssignment).decode, await roleAssignments.listForScope(scope, {
        // Notice: if you re-run this code quickly in succession, bear in mind that this filter does not immediately see role assignment created on previous run.
        // This will result in "RoleAssignmentExists" error.
        filter: `principalId eq '${principalId}'`, // It would be nice to have " and atScope()" at the end but unfortunately, not supported. I think there will be less results this way as opposed to just atScope()
    }))
        // The array contains also role assignments for anything within the subscription
        .filter((assignment) => assignment.scope === scope &&
        assignment.roleDefinitionId === roleDefinitionId)[0] ??
        (await roleAssignments.create(scope, uuid.v4(), {
            principalId,
            roleDefinitionId,
        })));
};
exports.upsertRoleAssignment = upsertRoleAssignment;
const roleAssignment = t.type({
    type: t.literal("Microsoft.Authorization/roleAssignments"),
    id: validation.nonEmptyString,
    name: validation.uuid,
    scope: validation.nonEmptyString,
    roleDefinitionId: validation.nonEmptyString,
    principalId: validation.uuid,
    principalType: t.union([
        t.literal("User"),
        t.literal("Group"),
        t.literal("ServicePrincipal"),
        t.literal("Unknown"),
        t.literal("DirectoryRoleTemplate"),
        t.literal("ForeignGroup"),
        t.literal("Application"),
        t.literal("MSI"),
        t.literal("DirectoryObjectOrGroup"),
        t.literal("Everyone"),
    ], "PrincipalType"),
}, "RoleAssignment");
//# sourceMappingURL=run-common.js.map