"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.config = exports.azure = exports.organization = exports.authenticationKinds = exports.authenticationKind = exports.booleanString = void 0;
const t = __importStar(require("io-ts"));
const validation = __importStar(require("@data-heaving/common-validation"));
exports.booleanString = t.refinement(t.string, (str) => ["true", "false"].indexOf(str.toLowerCase()) >= 0);
// The way to do initial authentication, in given order
exports.authenticationKind = t.union([t.literal("device"), t.literal("env"), t.literal("cli"), t.literal("msi")], "AuthenticationKind");
exports.authenticationKinds = t.array(exports.authenticationKind, "AuthenticationKindList");
const pipelineEncryptionKeyBits = t.union([t.number, t.null], "PulumiPipelineConfig");
exports.organization = t.type({
    name: validation.nonEmptyString,
    location: validation.nonEmptyString,
    environments: t.array(t.union([
        t.string,
        t.intersection([
            t.type({
                name: t.string,
            }, "EnvironmentInfoMandatory"),
            t.partial({
                location: validation.nonEmptyString,
                subscriptionId: validation.uuid,
            }, "EnvironmentInfoOptional"),
        ], "EnvironmentInfo"),
    ], "EnvironmentConfig"), "EnvironmentConfigList"),
}, "OrganizationConfig");
exports.azure = t.type({
    tenantId: validation.uuid,
    subscriptionId: validation.uuid,
}, "AzureConfig");
exports.config = t.intersection([
    t.type({
        bootstrapperApp: t.union([
            t.type({
                type: t.literal("msi"),
                clientId: validation.uuid,
                principalId: validation.uuid,
            }, "BootstrapperAppMSIConfig"),
            t.intersection([
                t.type({
                    type: t.literal("sp"),
                    displayName: validation.nonEmptyString,
                    authentication: t.intersection([
                        t.type({
                            certSubject: validation.nonEmptyString,
                        }, "BootstrapperAppSPAuthenticationConfigMandatory"),
                        t.partial({
                            rsaBits: t.Integer,
                            certValidityPeriodDays: t.Integer,
                            pfxPasswordEnvName: validation.nonEmptyString,
                        }, "BootstrapperAppSPAuthenticationConfigOptional"),
                    ], "BootstrapperAppSPAuthenticationConfig"),
                }, "BootstrapperAppSPConfigMandatory"),
                t.partial({
                    envSpecificPulumiPipelineSPAuth: t.intersection([
                        t.type({
                            subject: t.partial({
                                commonName: validation.nonEmptyString,
                                country: validation.nonEmptyString,
                                locality: validation.nonEmptyString,
                                organization: validation.nonEmptyString,
                                organizationalUnit: validation.nonEmptyString,
                                postalCode: validation.nonEmptyString,
                                province: validation.nonEmptyString,
                                serialNumber: validation.nonEmptyString,
                                streetAddresses: t.array(validation.nonEmptyString),
                            }, "EnvSpecificPulumiPipelinesSPAuthCertSubject"),
                        }, "EnvSpecificPulumiPipelinesSPAuthMandatory"),
                        t.partial({
                            rsaBits: t.Integer,
                            validityHours: t.Integer,
                        }, "EnvSpecificPulumiPipelinesSPAuthOptional"),
                    ], "EnvSpecificPulumiPipelinesSPAuth"),
                    configSecretName: t.string,
                }, "BootstrapperAppSPConfigOptional"),
            ], "BootstrapperAppSPConfig"),
        ], "BootstrapperAppConfig"),
        organization: exports.organization,
        azure: exports.azure,
    }, "BootstrapConfigMandatory"),
    t.partial({
        pulumi: t.partial({
            pulumiEncryptionKeyBitsForBootstrapper: pipelineEncryptionKeyBits,
            pulumiEncryptionKeyBitsForEnvSpecificPipeline: pipelineEncryptionKeyBits,
        }, "PulumiBootstrapConfigOptional"),
        namingConventions: t.partial({
            storageContainerPrefixString: t.string,
            keyNamePrefix: t.string,
            secretNamePrefix: t.string,
        }, "NamingConventionsConfigOptional"),
        logSubscriptionIdToConsole: t.boolean,
    }, "BootstrapConfigOptional"),
], "BootstrapConfig");
//# sourceMappingURL=cli-config.js.map