import * as t from "io-ts";
export declare const booleanString: t.RefinementC<t.StringC>;
export declare const authenticationKind: t.UnionC<
  [
    t.LiteralC<"device">,
    t.LiteralC<"env">,
    t.LiteralC<"cli">,
    t.LiteralC<"msi">,
  ]
>;
export declare type AuthenticationKind = t.TypeOf<typeof authenticationKind>;
export declare const authenticationKinds: t.ArrayC<
  t.UnionC<
    [
      t.LiteralC<"device">,
      t.LiteralC<"env">,
      t.LiteralC<"cli">,
      t.LiteralC<"msi">,
    ]
  >
>;
declare const pipelineEncryptionKeyBits: t.UnionC<[t.NumberC, t.NullC]>;
export declare type PulumiPipelineEncryptionKeyBits = t.TypeOf<
  typeof pipelineEncryptionKeyBits
>;
export declare const organization: t.TypeC<{
  name: t.RefinementC<t.StringC>;
  location: t.RefinementC<t.StringC>;
  environments: t.ArrayC<
    t.UnionC<
      [
        t.StringC,
        t.IntersectionC<
          [
            t.TypeC<{
              name: t.StringC;
            }>,
            t.PartialC<{
              location: t.RefinementC<t.StringC>;
              subscriptionId: t.RefinementC<t.StringC>;
            }>,
          ]
        >,
      ]
    >
  >;
}>;
export declare type Organization = t.TypeOf<typeof organization>;
export declare const azure: t.TypeC<{
  tenantId: t.RefinementC<t.StringC>;
  subscriptionId: t.RefinementC<t.StringC>;
}>;
export declare type AzureConfiguration = t.TypeOf<typeof azure>;
export declare const config: t.IntersectionC<
  [
    t.TypeC<{
      bootstrapperApp: t.UnionC<
        [
          t.TypeC<{
            type: t.LiteralC<"msi">;
            clientId: t.RefinementC<t.StringC>;
            principalId: t.RefinementC<t.StringC>;
          }>,
          t.IntersectionC<
            [
              t.TypeC<{
                type: t.LiteralC<"sp">;
                displayName: t.RefinementC<t.StringC>;
                authentication: t.IntersectionC<
                  [
                    t.TypeC<{
                      certSubject: t.RefinementC<t.StringC>;
                    }>,
                    t.PartialC<{
                      rsaBits: t.RefinementC<t.NumberC>;
                      certValidityPeriodDays: t.RefinementC<t.NumberC>;
                      pfxPasswordEnvName: t.RefinementC<t.StringC>;
                    }>,
                  ]
                >;
              }>,
              t.PartialC<{
                envSpecificPulumiPipelineSPAuth: t.IntersectionC<
                  [
                    t.TypeC<{
                      subject: t.PartialC<{
                        commonName: t.RefinementC<t.StringC>;
                        country: t.RefinementC<t.StringC>;
                        locality: t.RefinementC<t.StringC>;
                        organization: t.RefinementC<t.StringC>;
                        organizationalUnit: t.RefinementC<t.StringC>;
                        postalCode: t.RefinementC<t.StringC>;
                        province: t.RefinementC<t.StringC>;
                        serialNumber: t.RefinementC<t.StringC>;
                        streetAddresses: t.ArrayC<t.RefinementC<t.StringC>>;
                      }>;
                    }>,
                    t.PartialC<{
                      rsaBits: t.RefinementC<t.NumberC>;
                      validityHours: t.RefinementC<t.NumberC>;
                    }>,
                  ]
                >;
                configSecretName: t.StringC;
              }>,
            ]
          >,
        ]
      >;
      organization: t.TypeC<{
        name: t.RefinementC<t.StringC>;
        location: t.RefinementC<t.StringC>;
        environments: t.ArrayC<
          t.UnionC<
            [
              t.StringC,
              t.IntersectionC<
                [
                  t.TypeC<{
                    name: t.StringC;
                  }>,
                  t.PartialC<{
                    location: t.RefinementC<t.StringC>;
                    subscriptionId: t.RefinementC<t.StringC>;
                  }>,
                ]
              >,
            ]
          >
        >;
      }>;
      azure: t.TypeC<{
        tenantId: t.RefinementC<t.StringC>;
        subscriptionId: t.RefinementC<t.StringC>;
      }>;
    }>,
    t.PartialC<{
      pulumi: t.PartialC<{
        pulumiEncryptionKeyBitsForBootstrapper: t.UnionC<[t.NumberC, t.NullC]>;
        pulumiEncryptionKeyBitsForEnvSpecificPipeline: t.UnionC<
          [t.NumberC, t.NullC]
        >;
      }>;
      namingConventions: t.PartialC<{
        storageContainerPrefixString: t.StringC;
        keyNamePrefix: t.StringC;
        secretNamePrefix: t.StringC;
      }>;
      logSubscriptionIdToConsole: t.BooleanC;
    }>,
  ]
>;
export declare type Config = t.TypeOf<typeof config>;
export {};
