import * as common from "@data-heaving/common";
export const createBootstrapPipelineEventEmitterBuilder = () => new common.EventEmitterBuilder();
export const consoleLoggingBootstrapPipelineEventEmitterBuilder = (logMessagePrefix, builder, consoleAbstraction) => {
    if (!builder) {
        builder = createBootstrapPipelineEventEmitterBuilder();
    }
    const logger = common.createConsoleLogger(logMessagePrefix, consoleAbstraction);
    builder.addEventListener("beforeRunningPulumiPortion", (arg) => logger(`Starting Pulumi command "${arg.doChanges ? "up" : "preview"}" for environments ${arg.organization.environments
        .map(({ name }) => `"${name}"`)
        .join(", ")}.`));
    return builder;
};
//# sourceMappingURL=events.js.map